Package ru.bgcrm.model.process

# Class Process

java.lang.Object
org.bgerp.model.base.Id
org.bgerp.model.base.IdTitle
ru.bgcrm.model.process.Process

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Comparable<Process>`, `Id<Integer>`, `IdTitle<Integer>`, `Title`

public class Process extends IdTitle implements Comparable<Process>, Cloneable

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `LINK_TYPE_DEPEND`
  `static final String`
  `LINK_TYPE_LINK`
  `static final String`
  `LINK_TYPE_MADE`
  `static final String`
  `OBJECT_TYPE`

  ### Fields inherited from class org.bgerp.model.base.IdTitle

  `title`

  ### Fields inherited from class org.bgerp.model.base.Id

  `id`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Process()`
  `Process(int id)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Process`
  `clone()`
  `int`
  `compareTo(Process o)`
  `boolean`
  `equals(Object obj)`
  `Set<Integer>`
  `getAllowedToChangeStatusIds()`
  `String`
  `getChangesLog(Process oldProcess)`
  `Date`
  `getCloseTime()`
  `int`
  `getCloseUserId()`
  `Date`
  `getCreateTime()`
  `int`
  `getCreateUserId()`
  `String`
  `getDescription()`
  `Set<Integer>`
  `getExecutorIds()`
  `Set<Integer>`
  `getExecutorIdsWithGroupAndRole(int groupId, int roleId)`
  Returns the set of executor user IDs for the certain role and group.
  `Set<Integer>`
  `getExecutorIdsWithGroups(Set<Integer> groupIds)`
  Returns the set of executor user IDs for the certain groups.
  `Set<Integer>`
  `getExecutorIdsWithRole(int roleId)`
  Returns the set of executor user IDs for the certain role.
  `Set<Integer>`
  `getExecutorIdsWithRoles(Set<Integer> roleIds)`
  Returns the set of executor user IDs for the certain roles.
  `Set<ProcessExecutor>`
  `getExecutors()`
  `Set<Integer>`
  `getGroupIds()`
  `Set<Integer>`
  `getGroupIdsWithRole(int roleId)`
  Returns the set of execution group IDs for the certain role.
  `Set<Integer>`
  `getGroupIdsWithRoles(Set<Integer> roleIds)`
  Returns the set of execution group IDs for the certain roles.
  `ProcessGroups`
  `getGroups()`
  `int`
  `getPriority()`
  `String`
  `getPriorityColor()`
  Provides configured priority color
  `Set<ProcessExecutor>`
  `getProcessExecutors()`
  Deprecated.
  `Set<Integer>`
  `getProcessExecutorsInGroupWithRole(int roleId, int groupId)`
  Deprecated.
  `Set<Integer>`
  `getProcessExecutorsWithGroups(Set<Integer> groupIds)`
  Deprecated.
  `Set<Integer>`
  `getProcessExecutorsWithRole(int roleId)`
  Deprecated.
  `Set<Integer>`
  `getProcessExecutorsWithRoles(Set<Integer> roleIds)`
  Deprecated.
  `Set<ProcessGroup>`
  `getProcessGroups()`
  Deprecated.
  `Set<ProcessGroup>`
  `getProcessGroupWithRole(int roleId)`
  Deprecated.
  `Set<ProcessGroup>`
  `getProcessGroupWithRoles(Set<Integer> roleIds)`
  Deprecated.
  `Set<Integer>`
  `getRoleSet()`
  `Status`
  `getStatus()`
  `StatusChange`
  `getStatusChange()`
  `int`
  `getStatusId()`
  `Date`
  `getStatusTime()`
  `String`
  `getStatusTitle()`
  `int`
  `getStatusUserId()`
  `String`
  `getTitle()`
  `ProcessType`
  `getType()`
  `int`
  `getTypeId()`
  `String`
  `getTypeTitle()`
  `int`
  `hashCode()`
  `boolean`
  `isEqualProperties(Process process)`
  `void`
  `setCloseTime(Date closeTime)`
  `void`
  `setCloseUserId(int closeUserId)`
  `void`
  `setCreateTime(Date createTime)`
  `void`
  `setCreateUserId(int createUserId)`
  `void`
  `setDescription(String value)`
  `void`
  `setExecutors(Set<ProcessExecutor> value)`
  `void`
  `setGroups(ProcessGroups value)`
  `void`
  `setPriority(int priority)`
  `void`
  `setProcessExecutors(Set<ProcessExecutor> processExecutors)`
  Deprecated.
  `void`
  `setProcessGroups(Set<ProcessGroup> processGroups)`
  Deprecated.
  `void`
  `setStatusChange(StatusChange status)`
  `void`
  `setStatusId(int statusId)`
  `void`
  `setStatusTime(Date statusTime)`
  `void`
  `setStatusUserId(int statusUserId)`
  `void`
  `setTypeId(int value)`
  `String`
  `toString()`
  `Process`
  `withDescription(String value)`
  `Process`
  `withExecutors(Set<ProcessExecutor> value)`
  `Process`
  `withGroups(ProcessGroups value)`
  `Process`
  `withStatusId(int value)`
  `Process`
  `withTypeId(int value)`

  ### Methods inherited from class org.bgerp.model.base.IdTitle

  `setTitle, unknown`

  ### Methods inherited from class org.bgerp.model.base.Id

  `getId, setId`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.bgerp.model.base.iface.Id

  `getId`

- ## Field Details

  - ### OBJECT_TYPE

    public static final String OBJECT_TYPE
    See Also:
      - Constant Field Values

  - ### LINK_TYPE_LINK

    public static final String LINK_TYPE_LINK
    See Also:
      - Constant Field Values

  - ### LINK_TYPE_DEPEND

    public static final String LINK_TYPE_DEPEND
    See Also:
      - Constant Field Values

  - ### LINK_TYPE_MADE

    public static final String LINK_TYPE_MADE
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Process

    public Process()

  - ### Process

    public Process(int id)

- ## Method Details

  - ### getTypeId

    public int getTypeId()

  - ### setTypeId

    public void setTypeId(int value)

  - ### withTypeId

    public Process withTypeId(int value)

  - ### getType

    public ProcessType getType()
    Returns:
      process type object from `ProcessTypeCache.getProcessTypeSafe(int)`.

  - ### getTypeTitle

    public String getTypeTitle()
    Returns:
      process types title from `getType()`.

  - ### getCreateTime

    public Date getCreateTime()

  - ### setCreateTime

    public void setCreateTime(Date createTime)

  - ### getCreateUserId

    public int getCreateUserId()

  - ### setCreateUserId

    public void setCreateUserId(int createUserId)

  - ### getCloseUserId

    public int getCloseUserId()

  - ### setCloseUserId

    public void setCloseUserId(int closeUserId)

  - ### getCloseTime

    public Date getCloseTime()

  - ### setCloseTime

    public void setCloseTime(Date closeTime)

  - ### getStatusId

    public int getStatusId()

  - ### setStatusId

    public void setStatusId(int statusId)

  - ### withStatusId

    public Process withStatusId(int value)

  - ### getStatus

    public Status getStatus()
    Returns:
      process status object from `ProcessTypeCache.getStatusSafe(int)`.

  - ### getStatusTitle

    public String getStatusTitle()

  - ### getAllowedToChangeStatusIds

    public Set<Integer> getAllowedToChangeStatusIds()

  - ### getStatusTime

    public Date getStatusTime()

  - ### setStatusTime

    public void setStatusTime(Date statusTime)

  - ### getStatusUserId

    public int getStatusUserId()

  - ### setStatusUserId

    public void setStatusUserId(int statusUserId)

  - ### getStatusChange

    public StatusChange getStatusChange()

  - ### setStatusChange

    public void setStatusChange(StatusChange status)

  - ### getPriority

    public int getPriority()

  - ### setPriority

    public void setPriority(int priority)

  - ### getPriorityColor

    public String getPriorityColor()
    Provides configured priority color
    Returns:
      HTML color string or `null`

  - ### getTitle

    public String getTitle()
    Specified by:
      `getTitle` in interface `Title`
    Overrides:
      `getTitle` in class `IdTitle`

  - ### getDescription

    public String getDescription()

  - ### setDescription

    public void setDescription(String value)

  - ### withDescription

    public Process withDescription(String value)

  - ### getGroups

    public ProcessGroups getGroups()
    Returns:
      execution groups.

  - ### setGroups

    public void setGroups(ProcessGroups value)

  - ### withGroups

    public Process withGroups(ProcessGroups value)

  - ### getGroupIds

    public Set<Integer> getGroupIds()

  - ### getRoleSet

    public Set<Integer> getRoleSet()

  - ### getGroupIdsWithRole

    public Set<Integer> getGroupIdsWithRole(int roleId)
    Returns the set of execution group IDs for the certain role.
    Parameters:
      `roleId` -
    Returns:

  - ### getGroupIdsWithRoles

    public Set<Integer> getGroupIdsWithRoles(Set<Integer> roleIds)
    Returns the set of execution group IDs for the certain roles.
    Parameters:
      `roleIds` -
    Returns:

  - ### getExecutors

    public Set<ProcessExecutor> getExecutors()

  - ### setExecutors

    public void setExecutors(Set<ProcessExecutor> value)

  - ### withExecutors

    public Process withExecutors(Set<ProcessExecutor> value)

  - ### getExecutorIds

    public Set<Integer> getExecutorIds()

  - ### getExecutorIdsWithRole

    public Set<Integer> getExecutorIdsWithRole(int roleId)
    Returns the set of executor user IDs for the certain role.
    Parameters:
      `roleId` -
    Returns:

  - ### getExecutorIdsWithRoles

    public Set<Integer> getExecutorIdsWithRoles(Set<Integer> roleIds)
    Returns the set of executor user IDs for the certain roles.
    Parameters:
      `roleIds` -
    Returns:

  - ### getExecutorIdsWithGroupAndRole

    public Set<Integer> getExecutorIdsWithGroupAndRole(int groupId, int roleId)
    Returns the set of executor user IDs for the certain role and group.
    Parameters:
      `groupId` -
      `roleId` -
    Returns:

  - ### getExecutorIdsWithGroups

    public Set<Integer> getExecutorIdsWithGroups(Set<Integer> groupIds)
    Returns the set of executor user IDs for the certain groups.
    Parameters:
      `groupIds` -
    Returns:

  - ### getChangesLog

    public String getChangesLog(Process oldProcess)

  - ### compareTo

    public int compareTo(Process o)
    Specified by:
      `compareTo` in interface `Comparable<Process>`

  - ### equals

    public boolean equals(Object obj)
    Overrides:
      `equals` in class `Id`

  - ### isEqualProperties

    public boolean isEqualProperties(Process process)

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Id`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `IdTitle`

  - ### clone

    public Process clone()
    Overrides:
      `clone` in class `Object`

  - ### getProcessExecutors

    @Deprecated public Set<ProcessExecutor> getProcessExecutors()
    Deprecated.
    Use `getExecutors()`.

  - ### getProcessExecutorsWithRole

    @Deprecated public Set<Integer> getProcessExecutorsWithRole(int roleId)
    Deprecated.
    Use `getExecutorIdsWithRole(int)`.

  - ### getProcessExecutorsWithRoles

    @Deprecated public Set<Integer> getProcessExecutorsWithRoles(Set<Integer> roleIds)
    Deprecated.
    Use `getExecutorIdsWithRoles(Set)`.

  - ### getProcessExecutorsInGroupWithRole

    @Deprecated public Set<Integer> getProcessExecutorsInGroupWithRole(int roleId, int groupId)
    Deprecated.
    Use `getExecutorIdsWithGroupAndRole(int, int)`.

  - ### getProcessExecutorsWithGroups

    @Deprecated public Set<Integer> getProcessExecutorsWithGroups(Set<Integer> groupIds)
    Deprecated.
    Use `getExecutorIdsWithGroups(Set)`.

  - ### setProcessExecutors

    @Deprecated public void setProcessExecutors(Set<ProcessExecutor> processExecutors)
    Deprecated.
    Use `setExecutors(Set)`.

  - ### getProcessGroups

    @Deprecated public Set<ProcessGroup> getProcessGroups()
    Deprecated.
    Use `getGroups()`.

  - ### getProcessGroupWithRole

    @Deprecated public Set<ProcessGroup> getProcessGroupWithRole(int roleId)
    Deprecated.
    Use `getGroupIdsWithRole(int)`.

  - ### getProcessGroupWithRoles

    @Deprecated public Set<ProcessGroup> getProcessGroupWithRoles(Set<Integer> roleIds)
    Deprecated.
    Use `getGroupIdsWithRoles(Set)`.

  - ### setProcessGroups

    @Deprecated public void setProcessGroups(Set<ProcessGroup> processGroups)
    Deprecated.
    Use
    invalid reference

        #setGroups(Set)

    .